#!/usr/bin/env python3
# -*- coding: utf-8 -*-

# ====#====#====#====
# author = "jys"
# file: ut_sub.py
# time: 1/17/18 3:38 AM
# ====#====#====#====

import sys

sys.path.append("../../lib")

from leda_python.mbus import MbusBase
from gi.repository import GLib
import dbus.mainloop.glib
import logging
import json
import time
import threading

SUB_MBUS_WELL_KNOWN_NAME = "iot.dmp.subscribe"
SUB_MBUS_OBJECT_PATH = "/iot/dmp/subscribe"
SUB_MBUS_INTERFACE = "iot.dmp.subscribe"

_logger = logging.getLogger(__name__)


def createThread(task, args=()):
    t = threading.Thread(target=task, args=args)
    t.setDaemon(True)
    t.start()


def property_callBack(inparams):
    _logger.debug("propertiesChanged Msg: %s", inparams)


MyId = 0
MyFlag = True


def event_callBack(inparams):
    global MyId
    global MyFlag
    _logger.debug("propertiesChanged Msg: %s", inparams)
    msg = json.loads(inparams)
    # {"params": {"value": {"MsgId": 1}, "time": 1544540380072}}
    MyId = (MyId + 1) & 0xFFFF
    if ((MyId == msg['params']['value']['MsgId']) and (MyFlag == True)):
        # _logger.info('ok ...')
        pass
    else:
        MyFlag = False
        _logger.info('error ...')


def event_callBack2(inparams):
    _logger.debug("propertiesChanged Msg: %s", inparams)


if (__name__ == "__main__"):
    logging.basicConfig(level=logging.DEBUG)
    dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
    mbusConnectObject = MbusBase(SUB_MBUS_WELL_KNOWN_NAME)
    bus = mbusConnectObject.getBus()

    bus.add_signal_receiver(property_callBack, bus_name=None,
                            path=None, dbus_interface=None,
                            signal_name="propertiesChanged")

    bus.add_signal_receiver(event_callBack, bus_name=None,
                            path=None, dbus_interface=None,
                            signal_name="event")

    bus.add_signal_receiver(event_callBack2, bus_name=None,
                            path=None, dbus_interface=None,
                            signal_name="event2")
    mainloop = GLib.MainLoop()
    mainloop.run()
